diff --git a/src/include/c.h b/src/include/c.h
index f156886798..2b0835b988 100644
--- a/src/include/c.h
+++ b/src/include/c.h
@@ -1123,7 +1123,7 @@ extern void ExceptionalCondition(const char *conditionName,
 	((var) = ((var) < 0) ? 1 : -(var))
 
 /*
- * Use this, not "char buf[cluster_block_size]", to declare a field or local variable
+ * Use this, not "char buf[MAX_BLOCK_SIZE]", to declare a field or local variable
  * holding a page buffer, if that page might be accessed as a page.  Otherwise
  * the variable might be under-aligned, causing problems on alignment-picky
  * hardware.  We include both "double" and "int64" in the union to ensure that
@@ -1132,7 +1132,7 @@ extern void ExceptionalCondition(const char *conditionName,
  */
 typedef union PGAlignedBlock
 {
-	char		data[cluster_block_size];
+	char		data[MAX_BLOCK_SIZE];
 	double		force_align_d;
 	int64		force_align_i64;
 } PGAlignedBlock;
@@ -1150,7 +1150,7 @@ typedef union PGIOAlignedBlock
 #ifdef pg_attribute_aligned
 	pg_attribute_aligned(PG_IO_ALIGN_SIZE)
 #endif
-	char		data[cluster_block_size];
+	char		data[MAX_BLOCK_SIZE];
 	double		force_align_d;
 	int64		force_align_i64;
 } PGIOAlignedBlock;
diff --git a/src/include/common/blocksize.h b/src/include/common/blocksize.h
new file mode 100644
index 0000000000..b5fe75ea7b
--- /dev/null
+++ b/src/include/common/blocksize.h
@@ -0,0 +1,119 @@
+/*-------------------------------------------------------------------------
+ *
+ * blocksize.h
+ *	  defintions for cluster-specific limits/structure defs
+ *
+ *
+ * Copyright (c) 2023, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION: src/include/clustersizes.h
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#ifndef BLOCKSIZE_H
+#define BLOCKSIZE_H
+
+#ifndef DEFAULT_BLOCK_SIZE
+#define DEFAULT_BLOCK_SIZE 8192
+#endif
+
+#ifndef MIN_BLOCK_SIZE
+#define MIN_BLOCK_SIZE 1024
+#endif
+
+#ifndef MAX_BLOCK_SIZE
+#define MAX_BLOCK_SIZE 32*1024
+#endif
+
+#define IsValidBlockSize(size) ((size) >= MIN_BLOCK_SIZE && \
+								(size) <= MAX_BLOCK_SIZE && \
+								((size)&((size)-1)) == 0)
+
+/* identifiers only */
+typedef enum {
+	BLOCK_SIZE_UNSET = 0,
+	BLOCK_SIZE_1K,
+	BLOCK_SIZE_2K,
+	BLOCK_SIZE_4K,
+	BLOCK_SIZE_8K,
+	BLOCK_SIZE_16K,
+	BLOCK_SIZE_32K,
+} BlockSizeIdent;
+
+extern PGDLLIMPORT BlockSizeIdent cluster_block_setting;
+
+void BlockSizeInit(Size rawblocksize);
+#define cluster_block_bits (cluster_block_setting+9)
+#define cluster_block_size (1<<cluster_block_bits)
+// TODO: make this calculate using use DEFAULT_BLOCK_SIZE instead?
+#define DEFAULT_BLOCK_SIZE_BITS 13 
+#define cluster_relseg_size (RELSEG_SIZE << DEFAULT_BLOCK_SIZE_BITS >> cluster_block_bits)
+
+/* Specific calculations' now parameterized sources */
+
+/* originally in heaptoast.h */
+
+#define CalcMaximumBytesPerTuple(blocksize,tuplesPerPage)	\
+	MAXALIGN_DOWN((blocksize - \
+				   MAXALIGN(SizeOfPageHeaderData + (tuplesPerPage) * sizeof(ItemIdData))) \
+				  / (tuplesPerPage))
+
+#define CalcToastMaxChunkSize(blocksize) \
+	(CalcMaximumBytesPerTuple(blocksize,EXTERN_TUPLES_PER_PAGE) -	\
+	 MAXALIGN(SizeofHeapTupleHeader) -					\
+	 sizeof(Oid) -										\
+	 sizeof(int32) -									\
+	 VARHDRSZ)
+
+/* originally in htup_details.h */
+
+#define CalcMaxHeapTupleSize(size)  (size - MAXALIGN(SizeOfPageHeaderData + sizeof(ItemIdData)))
+
+#define CalcMaxHeapTuplesPerPage(size)									\
+	((int) (((size) - SizeOfPageHeaderData) /							\
+			(MAXALIGN(SizeofHeapTupleHeader) + sizeof(ItemIdData))))
+
+/* originally in itup.h */
+
+#define CalcMaxIndexTuplesPerPage(size)		\
+	((int) ((size - SizeOfPageHeaderData) / \
+			(MAXALIGN(sizeof(IndexTupleData) + 1) + sizeof(ItemIdData))))
+
+/* originally in nbtree_int.h */
+
+#define CalcMaxTIDsPerBTreePage(size)									\
+	(int) ((size - SizeOfPageHeaderData - sizeof(BTPageOpaqueData)) / \
+		   sizeof(ItemPointerData))
+
+/* originally in bloom.h */
+#define CalcFreeBlockNumberElems(size) (MAXALIGN_DOWN(size - SizeOfPageHeaderData - MAXALIGN(sizeof(BloomPageOpaqueData)) \
+													   - MAXALIGN(sizeof(uint16) * 2 + sizeof(uint32) + sizeof(BloomOptions)) \
+									 ) / sizeof(BlockNumber))
+
+#define BlockSizeDecl(calc) \
+	static inline unsigned int _block_size_##calc(BlockSizeIdent bsi) {	\
+	switch(bsi){														\
+	case BLOCK_SIZE_1K: return calc(1024); break;						\
+	case BLOCK_SIZE_2K: return calc(2048); break;						\
+	case BLOCK_SIZE_4K: return calc(4096); break;						\
+	case BLOCK_SIZE_8K: return calc(8192); break;						\
+	case BLOCK_SIZE_16K: return calc(16384); break;						\
+	case BLOCK_SIZE_32K: return calc(32768); break;						\
+	default: return 0;}}
+
+#define BlockSizeDecl2(calc)											\
+	static inline unsigned int _block_size_##calc(BlockSizeIdent bsi, unsigned int arg) { \
+	switch(bsi){														\
+	case BLOCK_SIZE_1K: return calc(1024,arg); break;						\
+	case BLOCK_SIZE_2K: return calc(2048,arg); break;						\
+	case BLOCK_SIZE_4K: return calc(4096,arg); break;						\
+	case BLOCK_SIZE_8K: return calc(8192,arg); break;						\
+	case BLOCK_SIZE_16K: return calc(16384,arg); break;					\
+	case BLOCK_SIZE_32K: return calc(32768,arg); break;					\
+	default: return 0;}}
+
+#define BlockSizeCalc(bsi,calc) _block_size_##calc(bsi)
+
+
+#endif
diff --git a/src/include/pg_config.h.in b/src/include/pg_config.h.in
index d8a2985567..acac7282b1 100644
--- a/src/include/pg_config.h.in
+++ b/src/include/pg_config.h.in
@@ -21,14 +21,15 @@
 /* The normal alignment of `short', in bytes. */
 #undef ALIGNOF_SHORT
 
-/* Size of a disk block --- this also limits the size of a tuple. You can set
-   it bigger if you need bigger tuples (although TOAST should reduce the need
-   to have large tuples, since fields can be spread across multiple tuples).
-   BLCKSZ must be a power of 2. The maximum possible value of BLCKSZ is
-   currently 2^15 (32768). This is determined by the 15-bit widths of the
-   lp_off and lp_len fields in ItemIdData (see include/storage/itemid.h).
-   Changing BLCKSZ requires an initdb. */
-#undef BLCKSZ
+/* Default size of a disk block --- this also limits the size of a tuple. You
+   can set it bigger if you need bigger tuples (although TOAST should reduce
+   the need to have large tuples, since fields can be spread across multiple
+   tuples).  DEFAULT_BLOCK_SIZE must be a power of 2. The maximum possible
+   value of DEFAULT_BLOCK_SIZE is currently 2^15 (32768). This is determined
+   by the 15-bit widths of the lp_off and lp_len fields in ItemIdData (see
+   include/storage/itemid.h).  Changing DEFAULT_BLOCK_SIZE requires an
+   initdb. */
+#undef DEFAULT_BLOCK_SIZE
 
 /* Saved arguments from configure */
 #undef CONFIGURE_ARGS
@@ -650,16 +651,16 @@
 #undef PTHREAD_CREATE_JOINABLE
 
 /* RELSEG_SIZE is the maximum number of blocks allowed in one disk file. Thus,
-   the maximum size of a single file is RELSEG_SIZE * BLCKSZ; relations bigger
-   than that are divided into multiple files. RELSEG_SIZE * BLCKSZ must be
-   less than your OS' limit on file size. This is often 2 GB or 4GB in a
-   32-bit operating system, unless you have large file support enabled. By
-   default, we make the limit 1 GB to avoid any possible integer-overflow
-   problems within the OS. A limit smaller than necessary only means we divide
-   a large relation into more chunks than necessary, so it seems best to err
-   in the direction of a small limit. A power-of-2 value is recommended to
-   save a few cycles in md.c, but is not absolutely required. Changing
-   RELSEG_SIZE requires an initdb. */
+   the maximum size of a single file is RELSEG_SIZE * cluster_block_size;
+   relations bigger than that are divided into multiple files. RELSEG_SIZE *
+   cluster_block_size must be less than your OS' limit on file size. This is
+   often 2 GB or 4GB in a 32-bit operating system, unless you have large file
+   support enabled. By default, we make the limit 1 GB to avoid any possible
+   integer-overflow problems within the OS. A limit smaller than necessary
+   only means we divide a large relation into more chunks than necessary, so
+   it seems best to err in the direction of a small limit. A power-of-2 value
+   is recommended to save a few cycles in md.c, but is not absolutely
+   required. Changing RELSEG_SIZE requires an initdb. */
 #undef RELSEG_SIZE
 
 /* The size of `bool', as computed by sizeof. */
@@ -774,7 +775,7 @@
 # endif
 #endif
 
-/* Size of a WAL file block. This need have no particular relation to BLCKSZ.
+/* Size of a WAL file block. This need have no particular relation to cluster_block_size.
    XLOG_BLCKSZ must be a power of 2, and if your system supports O_DIRECT I/O,
    XLOG_BLCKSZ must be a multiple of the alignment requirement for direct-I/O
    buffers, else direct I/O may fail. Changing XLOG_BLCKSZ requires an initdb.
diff --git a/src/include/pg_config_manual.h b/src/include/pg_config_manual.h
index 0446bfb407..70bddf2c7b 100644
--- a/src/include/pg_config_manual.h
+++ b/src/include/pg_config_manual.h
@@ -233,6 +233,14 @@
  */
 #define PG_IO_ALIGN_SIZE		4096
 
+/*
+ * Blocksize-related constants
+ */
+
+#define MIN_BLOCK_SIZE 1024
+#define MAX_BLOCK_SIZE 32768
+/* #define DEFAULT_BLOCK_SIZE 8192 */
+
 /*
  *------------------------------------------------------------------------
  * The following symbols are for enabling debugging code, not for
diff --git a/src/include/postgres.h b/src/include/postgres.h
index 8a028ff789..4651389fc2 100644
--- a/src/include/postgres.h
+++ b/src/include/postgres.h
@@ -45,6 +45,7 @@
 #include "c.h"
 #include "utils/elog.h"
 #include "utils/palloc.h"
+#include "common/blocksize.h"
 
 /* ----------------------------------------------------------------
  *				Section 1:	Datum type + support functions
diff --git a/src/include/postgres_ext.h b/src/include/postgres_ext.h
index 1ed3d694ee..240ad4e93b 100644
--- a/src/include/postgres_ext.h
+++ b/src/include/postgres_ext.h
@@ -70,5 +70,4 @@ typedef PG_INT64_TYPE pg_int64;
 #define PG_DIAG_SOURCE_LINE		'L'
 #define PG_DIAG_SOURCE_FUNCTION 'R'
 
-#define cluster_block_size BLCKSZ
 #endif							/* POSTGRES_EXT_H */
diff --git a/src/include/storage/bufpage.h b/src/include/storage/bufpage.h
index 20d8d7277a..a997380707 100644
--- a/src/include/storage/bufpage.h
+++ b/src/include/storage/bufpage.h
@@ -475,15 +475,15 @@ do { \
 	PageIsVerifiedExtended(page, blkno, \
 						   PIV_LOG_WARNING | PIV_REPORT_STAT)
 
-/*
- * Check that cluster_block_size is a multiple of sizeof(size_t).  In
- * PageIsVerifiedExtended(), it is much faster to check if a page is
- * full of zeroes using the native word size.  Note that this assertion
- * is kept within a header to make sure that StaticAssertDecl() works
- * across various combinations of platforms and compilers.
- */
-StaticAssertDecl(cluster_block_size == ((cluster_block_size / sizeof(size_t)) * sizeof(size_t)),
-				 "cluster_block_size has to be a multiple of sizeof(size_t)");
+/* /\* */
+/*  * Check that cluster_block_size is a multiple of sizeof(size_t).  In */
+/*  * PageIsVerifiedExtended(), it is much faster to check if a page is */
+/*  * full of zeroes using the native word size.  Note that this assertion */
+/*  * is kept within a header to make sure that StaticAssertDecl() works */
+/*  * across various combinations of platforms and compilers. */
+/*  *\/ */
+/* StaticAssertDecl(cluster_block_size == ((cluster_block_size / sizeof(size_t)) * sizeof(size_t)), */
+/* 				 "cluster_block_size has to be a multiple of sizeof(size_t)"); */
 
 extern void PageInit(Page page, Size pageSize, Size specialSize);
 extern bool PageIsVerifiedExtended(Page page, BlockNumber blkno, int flags);
diff --git a/src/include/storage/checksum.h b/src/include/storage/checksum.h
index 4afd25a0af..bea1cbd5b6 100644
--- a/src/include/storage/checksum.h
+++ b/src/include/storage/checksum.h
@@ -19,6 +19,6 @@
  * Compute the checksum for a Postgres page.  The page must be aligned on a
  * 4-byte boundary.
  */
-extern uint16 pg_checksum_page(char *page, BlockNumber blkno);
+extern uint16 pg_checksum_page(char *page, BlockNumber blkno, Size pagesize);
 
 #endif							/* CHECKSUM_H */
diff --git a/src/include/storage/checksum_impl.h b/src/include/storage/checksum_impl.h
index 18951c36c7..e51e04ec4a 100644
--- a/src/include/storage/checksum_impl.h
+++ b/src/include/storage/checksum_impl.h
@@ -101,6 +101,7 @@
  */
 
 #include "storage/bufpage.h"
+#include "common/blocksize.h"
 
 /* number of checksums to calculate in parallel */
 #define N_SUMS 32
@@ -111,7 +112,7 @@
 typedef union
 {
 	PageHeaderData phdr;
-	uint32		data[cluster_block_size / (sizeof(uint32) * N_SUMS)][N_SUMS];
+	uint32		data[MAX_BLOCK_SIZE / (sizeof(uint32) * N_SUMS)][N_SUMS];
 } PGChecksummablePage;
 
 /*
@@ -143,7 +144,7 @@ do { \
  * (at least on 4-byte boundary).
  */
 static uint32
-pg_checksum_block(const PGChecksummablePage *page)
+pg_checksum_block(const PGChecksummablePage *page, Size blocksize)
 {
 	uint32		sums[N_SUMS];
 	uint32		result = 0;
@@ -151,13 +152,13 @@ pg_checksum_block(const PGChecksummablePage *page)
 				j;
 
 	/* ensure that the size is compatible with the algorithm */
-	Assert(sizeof(PGChecksummablePage) == cluster_block_size);
+	Assert(cluster_block_size == blocksize);
 
 	/* initialize partial checksums to their corresponding offsets */
 	memcpy(sums, checksumBaseOffsets, sizeof(checksumBaseOffsets));
 
 	/* main checksum calculation */
-	for (i = 0; i < (uint32) (cluster_block_size / (sizeof(uint32) * N_SUMS)); i++)
+	for (i = 0; i < (uint32) (blocksize / (sizeof(uint32) * N_SUMS)); i++)
 		for (j = 0; j < N_SUMS; j++)
 			CHECKSUM_COMP(sums[j], page->data[i][j]);
 
@@ -184,7 +185,7 @@ pg_checksum_block(const PGChecksummablePage *page)
  * checksum itself), and the page data.
  */
 uint16
-pg_checksum_page(char *page, BlockNumber blkno)
+pg_checksum_page(char *page, BlockNumber blkno, Size pagesize)
 {
 	PGChecksummablePage *cpage = (PGChecksummablePage *) page;
 	uint16		save_checksum;
@@ -201,7 +202,7 @@ pg_checksum_page(char *page, BlockNumber blkno)
 	 */
 	save_checksum = cpage->phdr.pd_checksum;
 	cpage->phdr.pd_checksum = 0;
-	checksum = pg_checksum_block(cpage);
+	checksum = pg_checksum_block(cpage, pagesize);
 	cpage->phdr.pd_checksum = save_checksum;
 
 	/* Mix in the block number to detect transposed pages */
diff --git a/src/include/storage/freespace.h b/src/include/storage/freespace.h
index 9e1a85a141..4bbad4aaad 100644
--- a/src/include/storage/freespace.h
+++ b/src/include/storage/freespace.h
@@ -19,6 +19,7 @@
 #include "utils/relcache.h"
 
 /* prototypes for public functions in freespace.c */
+extern void FreeSpaceMapInit(void);
 extern Size GetRecordedFreeSpace(Relation rel, BlockNumber heapBlk);
 extern BlockNumber GetPageWithFreeSpace(Relation rel, Size spaceNeeded);
 extern BlockNumber RecordAndGetPageWithFreeSpace(Relation rel,
diff --git a/src/include/storage/large_object.h b/src/include/storage/large_object.h
index 9fab334c7b..9515df5f05 100644
--- a/src/include/storage/large_object.h
+++ b/src/include/storage/large_object.h
@@ -67,7 +67,9 @@ typedef struct LargeObjectDesc
  *
  * NB: Changing cluster_loblksize requires an initdb.
  */
+#define CalcLOBLKSIZE(size) (size/4)
 #define cluster_loblksize		(cluster_block_size / 4)
+#define LOBLKSIZE_LIMIT		CalcLOBLKSIZE(MAX_BLOCK_SIZE)
 
 /*
  * Maximum length in bytes for a large object.  To make this larger, we'd
diff --git a/src/include/storage/off.h b/src/include/storage/off.h
index 7fbd45a084..bfcd0a431f 100644
--- a/src/include/storage/off.h
+++ b/src/include/storage/off.h
@@ -25,7 +25,9 @@ typedef uint16 OffsetNumber;
 
 #define InvalidOffsetNumber		((OffsetNumber) 0)
 #define FirstOffsetNumber		((OffsetNumber) 1)
-#define MaxOffsetNumber			((OffsetNumber) (cluster_block_size / sizeof(ItemIdData)))
+#define CalcMaxOffsetNumber(size)			((OffsetNumber) (size / sizeof(ItemIdData)))
+#define MaxOffsetNumber			((OffsetNumber)CalcMaxOffsetNumber(cluster_block_size))
+#define MaxOffsetNumberLimit			((OffsetNumber)CalcMaxOffsetNumber(MAX_BLOCK_SIZE))
 
 /* ----------------
  *		support macros
diff --git a/src/include/utils/guc_tables.h b/src/include/utils/guc_tables.h
index d5a0880678..a47b6b6c2d 100644
--- a/src/include/utils/guc_tables.h
+++ b/src/include/utils/guc_tables.h
@@ -298,6 +298,7 @@ extern bool ConfigOptionIsVisible(struct config_generic *conf);
 /* get the current set of variables */
 extern struct config_generic **get_guc_variables(int *num_vars);
 
+extern void update_dynamic_gucs(void);
 extern void build_guc_variables(void);
 
 /* search in enum options */
diff --git a/src/tools/msvc/Mkvcbuild.pm b/src/tools/msvc/Mkvcbuild.pm
index db242c9205..7832c00b18 100644
--- a/src/tools/msvc/Mkvcbuild.pm
+++ b/src/tools/msvc/Mkvcbuild.pm
@@ -135,7 +135,7 @@ sub mkvcbuild
 	}
 
 	our @pgcommonallfiles = qw(
-	  archive.c base64.c binaryheap.c checksum_helper.c compression.c
+	  archive.c base64.c binaryheap.c blocksize.c checksum_helper.c compression.c
 	  config_info.c controldata_utils.c d2s.c encnames.c exec.c
 	  f2s.c file_perm.c file_utils.c hashfn.c ip.c jsonapi.c
 	  keywords.c kwlookup.c link-canary.c md5_common.c percentrepl.c
diff --git a/src/tools/msvc/Solution.pm b/src/tools/msvc/Solution.pm
index f6a40ae730..d7717d2bbc 100644
--- a/src/tools/msvc/Solution.pm
+++ b/src/tools/msvc/Solution.pm
@@ -212,10 +212,10 @@ sub GenerateFiles
 		ALIGNOF_PG_INT128_TYPE => undef,
 		ALIGNOF_SHORT => 2,
 		AC_APPLE_UNIVERSAL_BUILD => undef,
-		cluster_block_size => 1024 * $self->{options}->{blocksize},
 		CONFIGURE_ARGS => '"' . $self->GetFakeConfigure() . '"',
 		DEF_PGPORT => $port,
 		DEF_PGPORT_STR => qq{"$port"},
+		DEFAULT_BLOCK_SIZE => 1024 * $self->{options}->{blocksize},
 		DLSUFFIX => '".dll"',
 		ENABLE_GSS => $self->{options}->{gss} ? 1 : undef,
 		ENABLE_NLS => $self->{options}->{nls} ? 1 : undef,
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index 8de90c4958..25584219f0 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -894,7 +894,6 @@ Form_pg_ts_template
 Form_pg_type
 Form_pg_user_mapping
 FormatNode
-FreeBlockNumberArray
 FreeListData
 FreePageBtree
 FreePageBtreeHeader
-- 
2.40.1

